unit fDlgStockSel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, BaseGrid, AdvGrid, StdCtrls, Buttons;

type
  TfrmStockSel = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Edit1: TEdit;
    ListBox1: TListBox;
    Panel3: TPanel;
    g0: TAdvStringGrid;
    bbOK: TBitBtn;
    bbCancel: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure g0GetAlignment(Sender: TObject; ARow, ACol: Integer;
      var HAlign: TAlignment; var VAlign: TVAlignment);
    procedure g0MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
  private
    FSuspendFill: Boolean;
    FList_: TStringList;
    procedure FillSelections;
  public
    constructor Create(AOwner: TComponent; Selection: TStringList); reintroduce; virtual;
    function SelectedID: string;
    function SelectedName: string;
  end;

var
  frmStockSel: TfrmStockSel;

implementation

{$R *.dfm}

procedure TfrmStockSel.FormCreate(Sender: TObject);
begin
  g0.Rows[0].CommaText := '1,2,3';
  g0.Rows[1].CommaText := '4,5,6';
  g0.Rows[2].CommaText := '7,8,9';
  g0.Rows[3].CommaText := '0,,x';
end;

procedure TfrmStockSel.g0GetAlignment(Sender: TObject; ARow, ACol: Integer;
  var HAlign: TAlignment; var VAlign: TVAlignment);
begin
  HAlign := taCenter;
  VAlign := vtaCenter;
end;

procedure TfrmStockSel.g0MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  S: string;
  ACol, ARow: Integer;
begin
  g0.MouseToCell(X,Y,ACol,ARow);
  S := Edit1.Text;
        if (ACol = 2) and (ARow = 3) then  S := ''
  else  if (ACol = 1) and (ARow = 3) then  S := Copy(S,1,Length(S)-1)
  else  if Length(Edit1.Text)<4      then  S := S + g0.Cells[ACol,ARow];
  if S<>Edit1.Text then
  begin
    Edit1.Text := S;
    Edit1.SetFocus;
    Edit1.SelStart := Length(Edit1.Text);
    Edit1.SelLength := 0;
  end;
end;

function TfrmStockSel.SelectedID: string;
begin
  Result := Copy(Edit1.Text,1,4);
  if ListBox1.ItemIndex<>-1 then
  begin
    Result := Trim(ListBox1.Items[ListBox1.ItemIndex]);
    if Pos(' ',Result)>0 then Result := Trim(Copy(Result,1,4));
  end;
end;

procedure TfrmStockSel.ListBox1DblClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TfrmStockSel.ListBox1Click(Sender: TObject);
var
  I: Integer;
begin
  FSuspendFill := True;
  try
    I := ListBox1.ItemIndex;
    if I = -1 then Edit1.Text := ''
    else Edit1.Text := Copy(ListBox1.Items[I],1,4);
  finally
    FSuspendFill := False;
  end;
end;

procedure TfrmStockSel.FillSelections;
    function _ElimitBlank(S: string): string;
    var
      I: Integer;
    begin
      Result := '';
      for I := 1 to Length(S) do
        if S[I] <> #$20 then
          Result := Result + S[I];
    end;
var
  I, Len, K, X: Integer;
  Key,Key1,T: string;
  S: TStringList;
begin
  if FSuspendFill then EXIT;
  if FList_=nil then EXIT;
  //Conditional EXIT-------------------
  if (Edit1.Text = '') or (Edit1.Text = 'пJIDΦW')
  then ListBox1.Items.Text := FList_.Text
  else begin
    S := TStringList.Create;
    try
      Key := Trim(Edit1.Text);
      Len := Length(Key);
      for I := 0 to FList_.Count-1 do
      begin
        T := _ElimitBlank(FList_[I]);
        if Copy(t,1,Len) = Key then S.Add(FList_[I]);
      end;

      X := 0;
      ListBox1.Clear;
      for I := 0 to S.Count-1 do
      begin
        case StrToIntDef(Copy(S[I],1,2),-1) of
          03..09,70..73: ListBox1.Items.Add(S[I]);
          else begin
            ListBox1.Items.Insert(X,S[I]);
            Inc(X);
          end;
        end;
      end;

      Key1 := Key + ' ';

      ListBox1.ItemIndex := -1;
      if ListBox1.Count > 0 then
      begin
        for K := 0 to ListBox1.Items.Count-1 do
          if Key1 = Copy(ListBox1.Items[K],1,Len+1) then
          begin
            ListBox1.ItemIndex := K;
            Break;
          end;

        if ListBox1.ItemIndex = 0 then
          for K := 0 to ListBox1.Items.Count-1 do
            if Key = Copy(ListBox1.Items[K],1,Len) then
            begin
              ListBox1.ItemIndex := K;
              Break;
            end;
      end;
    finally
      FreeAndNil(S);
    end;

  end;
end;

procedure TfrmStockSel.Edit1Change(Sender: TObject);
begin
  if Length(Edit1.Text)>=4 then EXIT;
  FillSelections;
end;

procedure TfrmStockSel.FormActivate(Sender: TObject);
begin
  Edit1.SetFocus;
  Edit1.SelStart := Length(Edit1.Text)+1;
  Edit1.SelLength := 0;
  FillSelections;
end;

procedure TfrmStockSel.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key in [VK_UP, VK_DOWN] then
  begin
    ListBox1KeyDown(Sender, Key, Shift);
    if ListBox1.Count > 0 then
    begin
      FSuspendFill := True;
      try
        Edit1.Text := ListBox1.Items[ListBox1.ItemIndex];
        Edit1.SelStart := Length(Edit1.Text)+1;
        Edit1.SelLength := 0;
      finally
        FSuspendFill := False;
      end;
      Key := 0;
    end;
  end
  else inherited;
end;

procedure TfrmStockSel.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  N: Integer;
begin
  N := ListBox1.Count;
  if N = 0 then EXIT;
  //-----------------------------------------------------
  if ListBox1.ItemIndex = -1 then ListBox1.ItemIndex := 0
  else begin
    case Key of
      VK_UP:    ListBox1.ItemIndex := (ListBox1.ItemIndex - 1 + N) mod N;
      VK_DOWN : ListBox1.ItemIndex := (ListBox1.ItemIndex + 1 + N) mod N;
    end;
  end;
end;

procedure TfrmStockSel.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FList_);
end;

constructor TfrmStockSel.Create(AOwner: TComponent;
  Selection: TStringList);
begin
  inherited Create(AOwner);
  Edit1.Text := '';
  FList_ := TStringList.Create;
  FList_.Text := Selection.Text;
end;

function TfrmStockSel.SelectedName: string;
var
  P: Integer;
begin
  Result := '';
  if ListBox1.ItemIndex<>-1 then
  begin
    Result := Trim(ListBox1.Items[ListBox1.ItemIndex]);
    P := Pos(' ',Result);
    if P<1 then Result := ''
    else Result := Trim(Copy(Result,P+1,Length(Result)));
  end;
end;

end.
